use <x-end-motor-nema23.scad>
use <x-end-idler.scad>
use <x-carriage.scad>

$x_rod_length = 300;
$y_rod_length = 200;

module x_axis()
{
	// x-rods
	for ( x = [-25, 25] )
	{
		translate([x, 0, 0])
		rotate([90, 0, 0])
		cylinder(h = $x_rod_length, r=4, center=true);
	}

	// x-belt
	for ( z = [15.5, 32.5] )
	{
		translate([39, 35, z])
		cube([5, $x_rod_length-30, 2], center = true);
	}

	// y-rods
	for ( y = [-($x_rod_length/2 - 30), ($x_rod_length/2 - 30)] )
		{
		translate ([0, y, 24])
		rotate([0, 90, 0])
		cylinder(h = $y_rod_length, r=4, center=true);
		}

	// y-belts
	for ( z = [52.5, 69.5] )
	{
		for ( y = [52.5 - $x_rod_length/2, -35 + $x_rod_length/2] )
			{
			translate([0, y, z])
			cube([$y_rod_length, 5, 2], center = true);
			}
	}

	// x-carriage
	translate([0, 0, 12])
	rotate([180, 0, 0])
	x_carriage();

	// x-end-idler
	translate ([0, 72 - $x_rod_length/2, 13])
	x_end_idler();

	// x-end-motor
	translate ([0, 10 + $x_rod_length/2, 13])
	x_end_motor_nema23();
}

x_axis();
