include <configuration.scad>

module x_end_idler()
{
difference()
{
	union()
	{
		// backplane
		translate([-35,-33,-25])
		cube([70,3,63]);

		// support for belt clamps
		translate([-35,-33,28])
		cube([70,38,10]);

		// support for idler pulley and triangles
		translate([35, 0, 0])
		rotate([0, -90, 0])
		linear_extrude(height = 5)
		polygon(points=[[-25,-30],[19,-52],[38,-33],[38,5],[10,5]]);

		// support for rods
		translate([-35,-52,-25])
		cube([70, 22, 44]);
	}

	//holes for x-axis rods
	for( x = [-25, 25])
	{
		translate([x, -18, -12])
		rotate([90,0,0])
		rotate([0, 0, 22.5])
		cylinder(h = 120, r=4.5, $fn=8, center=true);
	}

	//nut traps and set screws to hold x-axis rods
	for ( x = [-25, 25])
	{
		// nut trap
		translate([x, -42, -16])
		cylinder(h = 8, r=m3_nut_diameter/2, $fn=6, center=true);

		// shaft for bolt
		translate([x, -42, -19])
		rotate([0, 0, 22.5])
		cylinder(h = 16, r=m3_diameter/2, $fn=8, center=true);
	}
	
	//belt clamp bolts
	for ( y = [-25, -5])
	{
		for ( x = [-25, 25])
		{
			// nut trap
			translate([x, y, 28])
			rotate([0, 0, 30])
			cylinder(h = 10, r=m3_nut_diameter/2, $fn=6, center=true);

			// shaft for bolt
			translate(v = [x, y, -20])
			rotate([0, 0, 22.5])
			cylinder(h = 200, r=m3_diameter/2, $fn=8, center=true);
		}
	}
	
	//idler pulley bolt
	translate([30,-15,11])
	rotate([0,90,0])
	rotate([0, 0, 22.5])
	cylinder(r=4,h=15, $fn=16, center = true);
	
	//hole for y-axis rod
	translate([0,-41,11])
	cube(size = [72, 16, 8], center = true);

	// Remove extra material between the x-axis rods
	translate(v = [-14, -49, -40])
	cube([28, 16, 80]);


	} // difference()
}

translate([0,20,35])
rotate([0, 90, 0])
x_end_idler();
