include <configuration.scad>


module nema23_connector()
{
	difference()
	{
		translate(v = [32.5, 9, 22.5])
		cube(size = [5,68,70], center = true);

		translate(v = [32.5, 10, 23.5])
		rotate(a=[0,90,0])
		rotate(a=[0,0,30])
		cylinder(h = 80, r=20, $fn=20, center=true);

		for( z = [23.5-23.5, 23.5+23.5] )
			for( y = [10-23.5, 10+23.5] )
				translate(v = [32.5, y, z]) cube(size = [20,5,10], center = true);
	}
}


module x_end_motor_nema23()
{
difference()
{
	union()
	{
		// back plane
		translate([-35, -42.5, -24.5])
		cube([70,5,63]);

		// support for x-axis-rods
		translate( [-35, -60, -24.5])
		cube([70,40,22.5]);

		// support for y-axis-rod
		translate([-35,-40,11])
		rotate([0,90,0])
		cylinder(r=8,h=70,$fn=16);

		// support for x-belt-clamps
		translate([-35, -60, 28.5])
		cube([70,40,10]);

		// nema23 connector
		translate(v = [0, 0, -12])
		nema23_connector();

		// triangle support
		translate([0, 0, -23])
		linear_extrude(height = 3, center = true)
		polygon(points=[[32.5,-22.5],[30,43],[-35,-20]]);

		// extra support for motor
		translate([30, -40, -24.5])
		cube([5,20,63]);

	} // union()


	// holes for x-axis rods
	for ( x = [-25, 25] )
	{
		translate([x, -18, -12])
		rotate([90,0,0])
		rotate([0, 0, 22.5])
		cylinder(h = 120, r=4.5, $fn=8, center=true);
	}

	// remove extra material between the x-axis rods
	translate( [-15, -65, -21.5])
	cube([30,50,16.5]);

	// hole for y-axis rod
	translate([-35,-40,11])
	rotate([0,90,0])
	translate([0,0,-50])
	cylinder(r=4,h=200,$fn=16);

	// x-belt-clamp bolts (and x-axis rod bolts)
	for ( x = [-25, 25] )
	{
		for ( y = [-30, -50] )
		{
			// shaft for bolt
			translate([x, y, 0])
			rotate([0, 0, 22.5])
			cylinder(h = 80, r=2.2, $fn=8, center=true);

			// nut trap for x-belt-clamp bolt
			translate(v = [x, y, 30])
			rotate([0, 0, 30])
			cylinder(h = 7, r=m3_nut_diameter/2, $fn=6, center=true);

			// nut trap for x-axis rod bolt
			translate(v = [x, y, -17])
			rotate([0, 0, 30])
			cylinder(h = 7, r=m3_nut_diameter/2, $fn=6, center=true);
		}
	}


} // difference()
}

// Put part in print orientation
translate(v = [-11,20,35])
rotate([0, 90, 0])
x_end_motor_nema23();
